// You can import API functions like this from D3.js.
import { select, csv } from 'd3';

const svg = select('svg');
 
const width=3000
const height=315

var datas = [];
csv("data.csv").then(data=>{
  datas = data;
  x.domain(data.map(d => d.Country));
    y.domain([0, d3.max(data, d => +d['2022 Population'])]);
  displayitem(data);
})

 const margin = {"top": 20, "left": 90, "right": 40, "bottom": 120}
const g = svg.append('g').attr("transform", "translate(" + margin.left + "," + margin.top + ")");
 
    svg.attr("width", width + margin.left + margin.right)
    .attr("height", height + margin.top + margin.bottom)

/*var request = new Request(
  'https://wasabi.i3s.unice.fr/api/v1/artist_all/name/Lara Fabian'
);

var songs = [];

fetch(request)
  .then((response) => response.json())
  .then((data) => {
  	console.log(data);
    data.albums.forEach((d) => {
      d.songs.forEach((s) => {
        songs.push(extractContent(s.lyrics));
      });
    });
    update(songs);
  });
  */


const div = select("body").append("div")
    .attr("class", "chart-tooltip")         
    .style("opacity", 0)
		.style("position", "absolute");

const button = select("body").append("button").text("croissant")
		.on("click", function(event) {
      			var sorted = datas.sort((a, b) => d3.ascending(+a["2022 Population"], +b["2022 Population"]));
            x.domain(sorted.map(d => d.Country));
            y.domain([0, d3.max(sorted, d => +d['2022 Population'])]);
            displayitem(sorted)
        })


const x = d3.scaleBand()
    .range([0, width])
    .padding(0.1);

const y = d3.scaleLinear()
    .range([height, 0]);

 var displayitem = function(data) {
   g.html("");
   //g.selectAll(".bar")
   //     .data(data).exit().remove();

    g.append("g")
        .attr("transform", "translate(0," + height + ")")
        .call(d3.axisBottom(x).tickSize(0))
        .selectAll("text")	
            .style("text-anchor", "end")
            .attr("dx", "-.8em")
            .attr("dy", ".15em")
            .attr("transform", "rotate(-65)");
    
    g.append("g")
        .call(d3.axisLeft(y).ticks(6));

    g.selectAll(".bar")
        .data(data)
    .enter().append("rect")
        .attr("class", "bar")
        .attr("x", d => x(d.Country))
        .attr("width", x.bandwidth())
        .attr("y", d => y(d['2022 Population']))
        .attr("height", d => (height - y(d['2022 Population'])))					
        .on("mouseover", function(d, event) {
            div.transition()        
                .duration(200)      
                .style("opacity", .9);
            div.html("Population : " + d['2022 Population'])
                .style("left", (d3.event.pageX + 10) + "px")     
                .style("top", (d3.event.pageY - 20) + "px");
        })
        .on("mouseout", function(event, d) {
            div.transition()
                .duration(500)
                .style("opacity", 0);
        });
}



